# Visualization
TKV3d
Voxel

# Voxel_Prs Class Reference

Interactive object for voxels.
.

`#include <Voxel_Prs.hxx>`

Inheritance diagram for Voxel_Prs:

[legend]

## Public Member Functions

Standard_EXPORT | Voxel_Prs ()
| An empty constructor. .
Standard_EXPORT void | SetBoolVoxels (const Standard_Address theVoxels)
| <thevoxels> is a Voxel_BoolDS* object.
Standard_EXPORT void | SetColorVoxels (const Standard_Address theVoxels)
| <thevoxels> is a Voxel_ColorDS* object.
Standard_EXPORT void | SetTriangulation (const Handle(Poly_Triangulation)&theTriangulation)
| Sets a triangulation for visualization. .
Standard_EXPORT void | SetDisplayMode (const Voxel_VoxelDisplayMode theMode)
| Sets a display mode for voxels. .
virtual Standard_EXPORT void | SetColor (const Quantity_Color &theColor)
| Defines the color of points, quadrangles ... for BoolDS. .
Standard_EXPORT void | SetColors (const Handle(Quantity_HArray1OfColor)&theColors)
| Defines the color of points, quadrangles... for ColorDS. For ColorDS the size of array is 0 .. 15. 0 - means no color, this voxel is not drawn. .
Standard_EXPORT void | SetPointSize (const Standard_Real theSize)
| Defines the size of points for all types of voxels. .
Standard_EXPORT void | SetQuadrangleSize (const Standard_Integer theSize)
| Defines the size of quadrangles in per cents (0 .. 100). .
virtual Standard_EXPORT void | SetTransparency (const Standard_Real theTransparency)
| Defines the transparency value [0 .. 1] for quadrangular visualization. .
Standard_EXPORT void | Highlight (const Standard_Integer ix, const Standard_Integer iy, const Standard_Integer iz)
| Highlights a voxel. It doesn't re-computes the whole interactive object, but only marks a voxels as "highlighted". The voxel becomes highlighted on next swapping of buffers. In order to unhighlight a voxel, set ix = iy = iz = -1. .
Standard_EXPORT void | Destroy ()
| A destructor of presentation data. .
| ~Voxel_Prs ()
Standard_EXPORT void | SetDegenerateMode (const Standard_Boolean theDegenerate)
| Simplifies visualization of voxels in case of view rotation, panning and zooming. .
Standard_EXPORT void | SetUsageOfGLlists (const Standard_Boolean theUsage)
| GL lists accelerate view rotation, panning and zooming operations, but it takes additional memory... It is up to the user of this interactive object to decide whether he has enough memory and may use GL lists or he is lack of memory and usage of GL lists is not recommended. By default, usage of GL lists is on. Also, as I noticed, the view without GL lists looks more precisely. .
Standard_EXPORT void | SetSmoothPoints (const Standard_Boolean theSmooth)
| Switches visualization of points from smooth to rough. .
Standard_EXPORT void | SetColorRange (const Standard_Byte theMinValue, const Standard_Byte theMaxValue)
| Defines min-max values for visualization of voxels of ColorDS structure. By default, min value = 1, max value = 15 (all non-zero values). .
Standard_EXPORT void | SetSizeRange (const Standard_Real theDisplayedXMin, const Standard_Real theDisplayedXMax, const Standard_Real theDisplayedYMin, const Standard_Real theDisplayedYMax, const Standard_Real theDisplayedZMin, const Standard_Real theDisplayedZMax)
| Defines the displayed area of voxels. By default, the range is equal to the box of voxels (all voxels are displayed). .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Protected Member Functions

virtual Standard_EXPORT void | Compute (const Handle(PrsMgr_PresentationManager3d)&thePresentationManager, const Handle(Prs3d_Presentation)&thePresentation, const Standard_Integer theMode=0)
| Calculates the 3D view aPresentation and its updates. The latter are managed by aPresentationManager. aPresentableObject has the display mode aMode; this has the default value of 0, that is, the wireframe display mode. .

## Private Member Functions

Standard_EXPORT void | ComputeSelection (const Handle(SelectMgr_Selection)&theSelection, const Standard_Integer theMode)

Recovers and calculates any sensitive primitive,
aSelection, available in Shape mode, specified by
aMode. As a rule, these are sensitive faces.
This method is defined as virtual. This enables you to
implement it in the creation of a new class of AIS
Interactive Object. You need to do this and in so
doing, redefine this method, if you create a class
which enriches the list of signatures and types.
.

Standard_EXPORT void | Allocate ()
| Allocates the data structure of visualization. .

## Private Attributes

Standard_Address | myVisData

## Constructor & Destructor Documentation

Standard_EXPORT Voxel_Prs::Voxel_Prs | ( |  | ) |

Voxel_Prs::~Voxel_Prs | ( |  | ) | `[inline]`

## Member Function Documentation

Standard_EXPORT void Voxel_Prs::Allocate | ( |  | ) | `[private]`

virtual Standard_EXPORT void Voxel_Prs::Compute | ( | const Handle(PrsMgr_PresentationManager3d)& | thePresentationManager,
|  | const Handle(Prs3d_Presentation)& | thePresentation,
|  | const Standard_Integer | theMode = `0`
| ) | `[protected, virtual]`

| Reimplemented from PrsMgr_PresentableObject.

Standard_EXPORT void Voxel_Prs::ComputeSelection | ( | const Handle(SelectMgr_Selection)& | theSelection,
|  | const Standard_Integer | theMode
| ) | `[private, virtual]`

| Implements SelectMgr_SelectableObject.

Standard_EXPORT void Voxel_Prs::Destroy | ( |  | ) |

Standard_EXPORT const Voxel_Prs::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from AIS_InteractiveObject.

Standard_EXPORT void Voxel_Prs::Highlight | ( | const Standard_Integer | ix,
|  | const Standard_Integer | iy,
|  | const Standard_Integer | iz
| ) |

Standard_EXPORT void Voxel_Prs::SetBoolVoxels | ( | const Standard_Address | theVoxels | ) |

virtual Standard_EXPORT void Voxel_Prs::SetColor | ( | const Quantity_Color & | theColor | ) | `[virtual]`

| Reimplemented from AIS_InteractiveObject.

Standard_EXPORT void Voxel_Prs::SetColorRange | ( | const Standard_Byte | theMinValue,
|  | const Standard_Byte | theMaxValue
| ) |

Standard_EXPORT void Voxel_Prs::SetColors | ( | const Handle(Quantity_HArray1OfColor)& | theColors | ) |

Standard_EXPORT void Voxel_Prs::SetColorVoxels | ( | const Standard_Address | theVoxels | ) |

Standard_EXPORT void Voxel_Prs::SetDegenerateMode | ( | const Standard_Boolean | theDegenerate | ) |

Standard_EXPORT void Voxel_Prs::SetDisplayMode | ( | const Voxel_VoxelDisplayMode | theMode | ) |

Standard_EXPORT void Voxel_Prs::SetPointSize | ( | const Standard_Real | theSize | ) |

Standard_EXPORT void Voxel_Prs::SetQuadrangleSize | ( | const Standard_Integer | theSize | ) |

Standard_EXPORT void Voxel_Prs::SetSizeRange | ( | const Standard_Real | theDisplayedXMin,
|  | const Standard_Real | theDisplayedXMax,
|  | const Standard_Real | theDisplayedYMin,
|  | const Standard_Real | theDisplayedYMax,
|  | const Standard_Real | theDisplayedZMin,
|  | const Standard_Real | theDisplayedZMax
| ) |

Standard_EXPORT void Voxel_Prs::SetSmoothPoints | ( | const Standard_Boolean | theSmooth | ) |

virtual Standard_EXPORT void Voxel_Prs::SetTransparency | ( | const Standard_Real | theTransparency | ) | `[virtual]`

| Reimplemented from AIS_InteractiveObject.

Standard_EXPORT void Voxel_Prs::SetTriangulation | ( | const Handle(Poly_Triangulation)& | theTriangulation | ) |

Standard_EXPORT void Voxel_Prs::SetUsageOfGLlists | ( | const Standard_Boolean | theUsage | ) |

## Field Documentation

Standard_Address Voxel_Prs::myVisData `[private]`

The documentation for this class was generated from the following file:

- Voxel_Prs.hxx